Re-fix rev-list-options documentation
[git/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
243a60fb
CC
3USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4LONG_USAGE='git bisect help
5 print this long help message.
6git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
38a47fd6
CC
7 reset bisect state and start bisection.
8git bisect bad [<rev>]
9 mark <rev> a known-bad revision.
10git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
6ca8b977
CC
12git bisect skip [<rev>...]
13 mark <rev>... untestable revisions.
38a47fd6
CC
14git bisect next
15 find next bisection to test and check it out.
16git bisect reset [<branch>]
17 finish bisection search and go back to branch.
18git bisect visualize
19 show bisect status in gitk.
20git bisect replay <logfile>
21 replay bisection log.
22git bisect log
23 show bisect log.
24git bisect run <cmd>...
243a60fb
CC
25 use <cmd>... to automatically bisect.
26
27Please use "git help bisect" to get the full man page.'
d025524d 28
8f321a39 29OPTIONS_SPEC=
ae2b0f15 30. git-sh-setup
4c550686 31require_work_tree
8cc6a083 32
ce32660e
JS
33_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
34_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
35
e9a45d75 36sq() {
d9bffc08 37 @@PERL@@ -e '
e9a45d75
JH
38 for (@ARGV) {
39 s/'\''/'\'\\\\\'\''/g;
40 print " '\''$_'\''";
41 }
42 print "\n";
43 ' "$@"
44}
45
8cc6a083 46bisect_autostart() {
823ea121 47 test -s "$GIT_DIR/BISECT_START" || {
8cc6a083
LT
48 echo >&2 'You need to start by "git bisect start"'
49 if test -t 0
50 then
51 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
52 read yesno
53 case "$yesno" in
54 [Nn]*)
55 exit ;;
56 esac
57 bisect_start
58 else
59 exit 1
60 fi
61 }
62}
63
64bisect_start() {
8cc6a083 65 #
634f2464 66 # Verify HEAD.
8cc6a083 67 #
48949a18 68 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
ce32660e
JS
69 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
70 die "Bad HEAD - I need a HEAD"
634f2464 71
ee831f7d 72 #
634f2464 73 # Check if we are bisecting.
ee831f7d 74 #
d3e54c88 75 start_head=''
634f2464
CC
76 if test -s "$GIT_DIR/BISECT_START"
77 then
78 # Reset to the rev from where we started.
9d0cd91c
CC
79 start_head=$(cat "$GIT_DIR/BISECT_START")
80 git checkout "$start_head" || exit
634f2464
CC
81 else
82 # Get rev from where we start.
83 case "$head" in
84 refs/heads/*|$_x40)
85 # This error message should only be triggered by
86 # cogito usage, and cogito users should understand
87 # it relates to cg-seek.
88 [ -s "$GIT_DIR/head-name" ] &&
89 die "won't bisect on seeked tree"
90 start_head="${head#refs/heads/}"
91 ;;
92 *)
93 die "Bad HEAD - strange symbolic ref"
94 ;;
95 esac
96 fi
8cc6a083
LT
97
98 #
634f2464 99 # Get rid of any old bisect state.
8cc6a083 100 #
823ea121 101 bisect_clean_state || exit
38a47fd6
CC
102
103 #
104 # Check for one bad and then some good revisions.
105 #
106 has_double_dash=0
107 for arg; do
108 case "$arg" in --) has_double_dash=1; break ;; esac
109 done
110 orig_args=$(sq "$@")
111 bad_seen=0
d3e54c88 112 eval=''
38a47fd6
CC
113 while [ $# -gt 0 ]; do
114 arg="$1"
115 case "$arg" in
116 --)
8fe26f44 117 shift
38a47fd6
CC
118 break
119 ;;
120 *)
634f2464 121 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
38a47fd6
CC
122 test $has_double_dash -eq 1 &&
123 die "'$arg' does not appear to be a valid revision"
124 break
125 }
737c74ee
CC
126 case $bad_seen in
127 0) state='bad' ; bad_seen=1 ;;
128 *) state='good' ;;
129 esac
d3e54c88 130 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
8fe26f44 131 shift
38a47fd6
CC
132 ;;
133 esac
8fe26f44 134 done
38a47fd6 135
ba963de8
CC
136 #
137 # Change state.
138 # In case of mistaken revs or checkout error, or signals received,
139 # "bisect_auto_next" below may exit or misbehave.
140 # We have to trap this to be able to clean up using
141 # "bisect_clean_state".
142 #
143 trap 'bisect_clean_state' 0
144 trap 'exit 255' 1 2 3 15
145
146 #
147 # Write new start state.
148 #
ba963de8 149 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
823ea121 150 sq "$@" >"$GIT_DIR/BISECT_NAMES" &&
ba963de8
CC
151 eval "$eval" &&
152 echo "git-bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
153 #
154 # Check if we can proceed to the next bisect state.
155 #
38a47fd6 156 bisect_auto_next
ba963de8
CC
157
158 trap '-' 0
8cc6a083
LT
159}
160
55624f9a
CC
161bisect_write() {
162 state="$1"
163 rev="$2"
737c74ee 164 nolog="$3"
55624f9a
CC
165 case "$state" in
166 bad) tag="$state" ;;
167 good|skip) tag="$state"-"$rev" ;;
168 *) die "Bad bisect_write argument: $state" ;;
169 esac
ba963de8 170 git update-ref "refs/bisect/$tag" "$rev" || exit
f454cdc4 171 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
ba963de8 172 test -n "$nolog" || echo "git-bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
55624f9a
CC
173}
174
155fc795 175bisect_state() {
8cc6a083 176 bisect_autostart
155fc795
CC
177 state=$1
178 case "$#,$state" in
179 0,*)
180 die "Please call 'bisect_state' with at least one argument." ;;
181 1,bad|1,good|1,skip)
182 rev=$(git rev-parse --verify HEAD) ||
183 die "Bad rev input: HEAD"
184 bisect_write "$state" "$rev" ;;
e3389075 185 2,bad|*,good|*,skip)
155fc795 186 shift
d3e54c88 187 eval=''
e3389075 188 for rev in "$@"
155fc795 189 do
a179a303 190 sha=$(git rev-parse --verify "$rev^{commit}") ||
e3389075 191 die "Bad rev input: $rev"
d3e54c88
CC
192 eval="$eval bisect_write '$state' '$sha'; "
193 done
194 eval "$eval" ;;
e3389075
CC
195 *,bad)
196 die "'git bisect bad' can take only one argument." ;;
cc9f24d0
JH
197 *)
198 usage ;;
8cc6a083 199 esac
97e1c51e
CC
200 bisect_auto_next
201}
202
8cc6a083 203bisect_next_check() {
0a5280a9
JH
204 missing_good= missing_bad=
205 git show-ref -q --verify refs/bisect/bad || missing_bad=t
206 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
6fecf191 207
0a5280a9
JH
208 case "$missing_good,$missing_bad,$1" in
209 ,,*)
210 : have both good and bad - ok
211 ;;
212 *,)
213 # do not have both but not asked to fail - just report.
214 false
215 ;;
216 t,,good)
217 # have bad but not good. we could bisect although
218 # this is less optimum.
219 echo >&2 'Warning: bisecting only with a bad commit.'
220 if test -t 0
221 then
222 printf >&2 'Are you sure [Y/n]? '
223 case "$(read yesno)" in [Nn]*) exit 1 ;; esac
224 fi
225 : bisect without good...
226 ;;
8cc6a083 227 *)
0a5280a9 228 THEN=''
823ea121 229 test -s "$GIT_DIR/BISECT_START" || {
0a5280a9
JH
230 echo >&2 'You need to start by "git bisect start".'
231 THEN='then '
232 }
233 echo >&2 'You '$THEN'need to give me at least one good' \
234 'and one bad revisions.'
235 echo >&2 '(You can use "git bisect bad" and' \
236 '"git bisect good" for that.)'
237 exit 1 ;;
8cc6a083
LT
238 esac
239}
240
241bisect_auto_next() {
434d036f 242 bisect_next_check && bisect_next || :
8cc6a083
LT
243}
244
42ba5ee7
CC
245eval_rev_list() {
246 _eval="$1"
247
248 eval $_eval
249 res=$?
250
251 if [ $res -ne 0 ]; then
252 echo >&2 "'git rev-list --bisect-vars' failed:"
253 echo >&2 "maybe you mistake good and bad revs?"
254 exit $res
255 fi
256
257 return $res
258}
259
97e1c51e
CC
260filter_skipped() {
261 _eval="$1"
262 _skip="$2"
263
264 if [ -z "$_skip" ]; then
42ba5ee7 265 eval_rev_list "$_eval"
97e1c51e
CC
266 return
267 fi
268
269 # Let's parse the output of:
270 # "git rev-list --bisect-vars --bisect-all ..."
42ba5ee7 271 eval_rev_list "$_eval" | while read hash line
97e1c51e
CC
272 do
273 case "$VARS,$FOUND,$TRIED,$hash" in
274 # We display some vars.
275 1,*,*,*) echo "$hash $line" ;;
276
277 # Split line.
278 ,*,*,---*) ;;
279
280 # We had nothing to search.
281 ,,,bisect_rev*)
282 echo "bisect_rev="
283 VARS=1
284 ;;
285
286 # We did not find a good bisect rev.
287 # This should happen only if the "bad"
288 # commit is also a "skip" commit.
289 ,,*,bisect_rev*)
290 echo "bisect_rev=$TRIED"
291 VARS=1
292 ;;
293
294 # We are searching.
295 ,,*,*)
296 TRIED="${TRIED:+$TRIED|}$hash"
297 case "$_skip" in
298 *$hash*) ;;
299 *)
300 echo "bisect_rev=$hash"
301 echo "bisect_tried=\"$TRIED\""
302 FOUND=1
303 ;;
304 esac
305 ;;
306
307 # We have already found a rev to be tested.
308 ,1,*,bisect_rev*) VARS=1 ;;
309 ,1,*,*) ;;
310
311 # ???
312 *) die "filter_skipped error " \
313 "VARS: '$VARS' " \
314 "FOUND: '$FOUND' " \
315 "TRIED: '$TRIED' " \
316 "hash: '$hash' " \
317 "line: '$line'"
318 ;;
319 esac
320 done
321}
322
323exit_if_skipped_commits () {
324 _tried=$1
325 if expr "$_tried" : ".*[|].*" > /dev/null ; then
326 echo "There are only 'skip'ped commit left to test."
327 echo "The first bad commit could be any of:"
e23cb8c0 328 echo "$_tried" | tr '[|]' '[\012]'
97e1c51e
CC
329 echo "We cannot bisect more!"
330 exit 2
331 fi
332}
333
8cc6a083 334bisect_next() {
8fe26f44 335 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 336 bisect_autostart
0a5280a9
JH
337 bisect_next_check good
338
97e1c51e 339 skip=$(git for-each-ref --format='%(objectname)' \
40a7ce64 340 "refs/bisect/skip-*" | tr '\012' ' ') || exit
97e1c51e
CC
341
342 BISECT_OPT=''
343 test -n "$skip" && BISECT_OPT='--bisect-all'
344
5be60078 345 bad=$(git rev-parse --verify refs/bisect/bad) &&
0a5280a9 346 good=$(git for-each-ref --format='^%(objectname)' \
40a7ce64 347 "refs/bisect/good-*" | tr '\012' ' ') &&
97e1c51e 348 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
0a5280a9 349 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
97e1c51e 350 eval=$(filter_skipped "$eval" "$skip") &&
0a5280a9
JH
351 eval "$eval" || exit
352
353 if [ -z "$bisect_rev" ]; then
354 echo "$bad was both good and bad"
355 exit 1
670f5fe3 356 fi
0a5280a9 357 if [ "$bisect_rev" = "$bad" ]; then
97e1c51e 358 exit_if_skipped_commits "$bisect_tried"
0a5280a9 359 echo "$bisect_rev is first bad commit"
5be60078 360 git diff-tree --pretty $bisect_rev
0a5280a9 361 exit 0
8cc6a083 362 fi
0a5280a9 363
97e1c51e
CC
364 # We should exit here only if the "bad"
365 # commit is also a "skip" commit (see above).
366 exit_if_skipped_commits "$bisect_rev"
367
0a5280a9 368 echo "Bisecting: $bisect_nr revisions left to test after this"
634f2464 369 git checkout -q "$bisect_rev" || exit
5be60078 370 git show-branch "$bisect_rev"
8cc6a083
LT
371}
372
cc9f24d0
JH
373bisect_visualize() {
374 bisect_next_check fail
235997c9
JH
375
376 if test $# = 0
377 then
508e84a7 378 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
235997c9 379 '') set git log ;;
508e84a7 380 set*) set gitk ;;
235997c9
JH
381 esac
382 else
383 case "$1" in
384 git*|tig) ;;
385 -*) set git log "$@" ;;
386 *) set git "$@" ;;
387 esac
388 fi
389
e3f062bf 390 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
235997c9 391 eval '"$@"' refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
392}
393
8cc6a083 394bisect_reset() {
823ea121 395 test -s "$GIT_DIR/BISECT_START" || {
fce0499f
CC
396 echo "We are not bisecting."
397 return
398 }
8cc6a083 399 case "$#" in
823ea121 400 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
737c74ee
CC
401 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
402 die "$1 does not seem to be a valid branch"
8cc6a083 403 branch="$1" ;;
8fe26f44 404 *)
8cc6a083
LT
405 usage ;;
406 esac
9d0cd91c 407 git checkout "$branch" && bisect_clean_state
e204de28
JH
408}
409
38a47fd6 410bisect_clean_state() {
947a604b 411 # There may be some refs packed during bisection.
634f2464 412 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
947a604b
CC
413 while read ref hash
414 do
823ea121 415 git update-ref -d $ref $hash || exit
947a604b 416 done
823ea121
CC
417 rm -f "$GIT_DIR/BISECT_LOG" &&
418 rm -f "$GIT_DIR/BISECT_NAMES" &&
419 rm -f "$GIT_DIR/BISECT_RUN" &&
9d0cd91c 420 # Cleanup head-name if it got left by an old version of git-bisect
823ea121
CC
421 rm -f "$GIT_DIR/head-name" &&
422
423 rm -f "$GIT_DIR/BISECT_START"
38a47fd6
CC
424}
425
e204de28 426bisect_replay () {
737c74ee 427 test -r "$1" || die "cannot read $1 for replaying"
e204de28
JH
428 bisect_reset
429 while read bisect command rev
430 do
431 test "$bisect" = "git-bisect" || continue
432 case "$command" in
433 start)
e9a45d75 434 cmd="bisect_start $rev"
737c74ee
CC
435 eval "$cmd" ;;
436 good|bad|skip)
437 bisect_write "$command" "$rev" ;;
e204de28 438 *)
737c74ee 439 die "?? what are you talking about?" ;;
e204de28
JH
440 esac
441 done <"$1"
442 bisect_auto_next
8cc6a083
LT
443}
444
a17c4101 445bisect_run () {
83020120
CC
446 bisect_next_check fail
447
a17c4101
CC
448 while true
449 do
450 echo "running $@"
451 "$@"
452 res=$?
453
454 # Check for really bad run error.
455 if [ $res -lt 0 -o $res -ge 128 ]; then
456 echo >&2 "bisect run failed:"
457 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
458 exit $res
459 fi
460
155fc795 461 # Find current state depending on run success or failure.
71b0251c
CC
462 # A special exit code of 125 means cannot test.
463 if [ $res -eq 125 ]; then
464 state='skip'
465 elif [ $res -gt 0 ]; then
155fc795 466 state='bad'
a17c4101 467 else
155fc795 468 state='good'
a17c4101
CC
469 fi
470
155fc795
CC
471 # We have to use a subshell because "bisect_state" can exit.
472 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
a17c4101
CC
473 res=$?
474
475 cat "$GIT_DIR/BISECT_RUN"
476
71b0251c
CC
477 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
478 > /dev/null; then
479 echo >&2 "bisect run cannot continue any more"
480 exit $res
481 fi
482
a17c4101
CC
483 if [ $res -ne 0 ]; then
484 echo >&2 "bisect run failed:"
155fc795 485 echo >&2 "'bisect_state $state' exited with error code $res"
a17c4101
CC
486 exit $res
487 fi
488
489 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
490 echo "bisect run success"
491 exit 0;
492 fi
493
494 done
495}
496
497
8cc6a083
LT
498case "$#" in
4990)
500 usage ;;
501*)
502 cmd="$1"
503 shift
504 case "$cmd" in
243a60fb
CC
505 help)
506 git bisect -h ;;
8cc6a083
LT
507 start)
508 bisect_start "$@" ;;
155fc795
CC
509 bad|good|skip)
510 bisect_state "$cmd" "$@" ;;
8cc6a083
LT
511 next)
512 # Not sure we want "next" at the UI level anymore.
513 bisect_next "$@" ;;
235997c9 514 visualize|view)
cc9f24d0 515 bisect_visualize "$@" ;;
8cc6a083
LT
516 reset)
517 bisect_reset "$@" ;;
e204de28
JH
518 replay)
519 bisect_replay "$@" ;;
520 log)
521 cat "$GIT_DIR/BISECT_LOG" ;;
a17c4101
CC
522 run)
523 bisect_run "$@" ;;
8cc6a083
LT
524 *)
525 usage ;;
526 esac
527esac